#!/bin/sh

if [ $# -lt 2 ]
then
echo "Please specify the language and the path to SRILM ngram-count. \n\nUsage: ./runmefirst.sh <en/zh> <path/to/srilm/ngram-count>"
exit 1
fi


LANG=$1
SRILM=$2

echo "
## This is the configration file for English experiments
## Note: for absolute paths, please avoid spaces in the path name.
##

# the language
lang		$LANG	

# choose either unigram or bigram
gram		bigram

# the number of bigram EM iterations.
iterations 	10

# the path which contains the "data" folder, must be an absolute path
datadir 	$PWD/data/geo-lambda/split/$LANG/

# the location of the learned model, must be an absolute path
modeldir	$PWD/model/geo-lambda/split/$LANG/

# debug mode? to turn off, set this to false
debug		true

# language model order, in current version only trigram is supported.
lmorder		3

# the file to store the learned language model
lmfile		$PWD/data/geo-lambda/split/$LANG/order3.srilm

# srilm path, i.e. ** the folder that contains the executable "ngram-count" **
srilm		$2

" > $LANG.cfg