/*
 * BareIndex.java
 *
 * Created on June 5, 2007, 8:42 PM
 *
 */

package lambdacalc.lf;

import lambdacalc.logic.Expr;

/**
 *
 * @author champoll
 */
public class BareIndex extends Terminal {
    
    public BareIndex(String label, int i) {
        this.setLabel(label);
        this.setIndex(i);
    }
    
    public BareIndex(int i) {
        this.setIndex(i);
    }
    
//    public String getLabel() {
//        return this.getIndex()+"";
//    }
//    
//    public void setLabel(String label) {
//        throw new UnsupportedOperationException("Tried to set the label of a bare index.");
//    }
    
    @Override
	public void setIndex(int index) {
        if (index == -1) {
            throw new UnsupportedOperationException("Tried to remove the index of a bare index.");
        }
        super.setIndex(index);
    }
    
    @Override
	public void removeIndex() {
        throw new UnsupportedOperationException("Tried to remove the index of a bare index.");
    }
    
    @Override
	public String getDisplayName() {
        return "Bare index";
    }
    
    @Override
	public boolean isMeaningful() {
        return false;
    }
    
    @Override
	public Expr getMeaning(AssignmentFunction g) 
    throws MeaningEvaluationException {
        throw new MeaningEvaluationException("The bare index \"" + toShortString() + "\" has no denotation.");
    }
    
    /**
     * Nothing to do on a BareIndex.
     *
     * @param lexicon the lexicon
     */
    @Override
	public void guessLexicalEntries(Lexicon lexicon) {
    
    }
    
    
    @Override
	public String toString() {
        if (this.getLabel() == null) {
            return Integer.toString(this.getIndex());
        } else {
            return super.toString();
        }
    }
}
