/*
 * And.java
 *
 * Created on May 29, 2006, 3:22 PM
 */

package lambdacalc.logic;

import java.awt.event.KeyEvent;
import java.util.Map;

/**
 * Represents the conjunction binary connective.
 */
public class And extends LogicalBinary {

    /**
     * The wedge character
     */
    public static final char SYMBOL = '^';

    public static final char INPUT_SYMBOL = '&';

//    public static final char ALTERNATE_INPUT_SYMBOL = '^';

    public static final int KEY_EVENT = KeyEvent.VK_AMPERSAND;

    /**
     * Constructs the connective.
     * @param left the expression on the left side of the connective
     * @param right the expression on the right side of the connective
     */
    public And(Expr left, Expr right) {
        super(left, right);
    }

    @Override
	public int getExprCat(){
        return super.AND;
    }

    @Override
	public String getSymbol() {
        return String.valueOf(SYMBOL);
    }

    @Override
	protected Binary create(Expr left, Expr right) {
        return new And(left, right);
    }

    @Override
	protected boolean equals(Expr e, boolean useMaps, Map thisMap, Map otherMap, boolean collapseAllVars) {
        // ignore parentheses for equality test
        e = e.stripOutermostParens();

        if (e instanceof And) {
            return this.equals((And) e, useMaps, thisMap, otherMap, collapseAllVars);
        } else {
            return false;
        }
    }

    private boolean equals(And b, boolean useMaps, Map thisMap, Map otherMap, boolean collapseAllVars) {
        boolean res1 = equalsHelper(b) && this.getLeft().equals(b.getLeft(), useMaps, thisMap, otherMap, collapseAllVars) &&
                       this.getRight().equals(b.getRight(), useMaps, thisMap, otherMap, collapseAllVars);

        boolean res2 = equalsHelper(b) && this.getRight().equals(b.getLeft(), useMaps, thisMap, otherMap, collapseAllVars) &&
                       this.getLeft().equals(b.getRight(), useMaps, thisMap, otherMap, collapseAllVars);

        return res1 || res2;
    }


    And(java.io.DataInputStream input) throws java.io.IOException {
        super(input);
    }

}



