/**
 *  A Probabilistic Forest-to-String Model for Language Generation from Typed Lambda Calculus Expressions
 *
 *  Copyright (C) 2011  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package lambdagen.util;

/**
 * @author Wei LU
 * @version 1.0
 */

public class KeyValPair<X, Y> implements Comparable<KeyValPair<X, Y>>{
	private X _x;
	private Y _y;
	
	public KeyValPair(X x, Y y){
		this._x = x;
		this._y = y;
	}
	
	public X getKey(){
		return this._x;
	}
	
	public Y getVal(){
		return this._y;
	}
	
	public void setVal(Y y){
		this._y = y;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	public int compareTo(KeyValPair<X, Y> kvp) {
		return ((Comparable) this._x).compareTo(kvp._x);
	}
	
	@Override
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append('\n');
		sb.append('[');
		sb.append(this._x);
		sb.append('\t');
		sb.append(this._y);
		sb.append(']');
		return sb.toString();
	}
	
}
