/**
 *  A Probabilistic Forest-to-String Model for Language Generation from Typed Lambda Calculus Expressions
 *
 *  Copyright (C) 2011  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package lambdagen.util;

import java.util.List;

import lambdacalc.logic.Expr;

/**
 * @author Wei LU
 * @version 1.0
 */

public class LambdaUtil {

	/**
	 * Check if the expression contains a certain type in any of its sub-expression.
	 * @param exp
	 * @param cat
	 * @return
	 */
	public static boolean contains(Expr exp, int cat){
		if(exp.getExprCat() == cat){
			return true;
		}
		List<Expr> list = exp.getSubExpressions();
		for(int i = 0; i<list.size(); i++){
			Expr e = list.get(i);
			if(contains(e, cat)){
				return true;
			}
		}
		return false;
	}
}
