/**
 *  A Probabilistic Forest-to-String Model for Language Generation from Typed Lambda Calculus Expressions
 *
 *  Copyright (C) 2011  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package lambdagen.util;

/**
 * @author Wei LU
 * @version 1.0
 */

public class Logger {
    public Logger() {
    }

    public static void dot(int val, int size) {
        if (val % size == 0) {
            System.err.print('.');
        }
    }
    
    public static void count(long pointer, long total){
    	if(pointer < total){
    		System.err.print("\r[COUNT]\t"+pointer+"/"+total);
    	} else {
    		System.err.println("\r[COUNT]\t"+pointer+"/"+total);
    	}
    }
    
    public static void count(long pointer, long total, long extra){
    	if(pointer < total){
    		System.err.print("\r[COUNT]\t"+pointer+"/"+total+"/"+extra);
    	} else {
    		System.err.println("\r[COUNT]\t"+pointer+"/"+total+"/"+extra);
    	}
    }

    public static void info(String msg) {
//        System.err.println("[INFO]\t" + msg);
    }

    public static void alert(String msg) {
        System.out.println("[MSG]\t" + msg);
    }

    public static void warn(String msg) {
        System.err.println("[WARN]\t" + msg);
    }

    public static void error(String msg) {
        throw new RuntimeException("[ERROR]\t" + msg);
    }

    public static void debug(String msg){
    	System.err.println("[BUG]\t"+msg);
    }
}
