/**
 *  A Probabilistic Forest-to-String Model for Language Generation from Typed Lambda Calculus Expressions
 *
 *  Copyright (C) 2011  LU, Wei (luwei@statnlp.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package lambdagen.util;

import java.util.*;  

/**
 * @author Wei LU
 * @version 1.0
 */

public class Tester {  

	private int a;  
	private String b;  
	
	public Tester(int a, String b) {  
		this.a = a;  
		this.b = b;  
	}
	
	@Override
	public boolean equals(Object o) {
		if(o instanceof Tester){
			Tester other = (Tester)o;
			if(a != other.a){
				return false;
			}
			if(!b.equals(other.b)){
				return false;
			}
			return true;
		}
		return false;
	}
	
	@Override
	public int hashCode() {  
	    int hash = a * 31;
	    hash += (b == null ? 0 : b.hashCode());
	    return hash;  
	}
	
	public static void main(String[] args) {
	  HashMap<Tester, String> map = new HashMap<Tester, String>();  

	  Tester k1 = new Tester(1,"1");  
	  map.put(k1,"value1");  
	  
	  Tester k2 = new Tester(1,"1");

	  System.out.println("map.get(k2): " + map.get(k2));  
	  System.out.println("k2.equals(k1) " + k2.equals(k1));  
	  System.out.println("k2.hashCode() " + k2.hashCode());  
	  System.out.println("k1.hashCode() " + k1.hashCode());  
	}
	
}



